/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DiscoveryEngineCmekConfigConfig extends cdktf.TerraformMetaArguments {
    /**
    * The unique id of the cmek config.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#cmek_config_id DiscoveryEngineCmekConfig#cmek_config_id}
    */
    readonly cmekConfigId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#id DiscoveryEngineCmekConfig#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * KMS key resource name which will be used to encrypt resources
    * 'projects/{project}/locations/{location}/keyRings/{keyRing}/cryptoKeys/{keyId}'.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#kms_key DiscoveryEngineCmekConfig#kms_key}
    */
    readonly kmsKey: string;
    /**
    * The geographic location where the CMEK config should reside. The value can
    * only be one of "us" and "eu".
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#location DiscoveryEngineCmekConfig#location}
    */
    readonly location: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#project DiscoveryEngineCmekConfig#project}
    */
    readonly project?: string;
    /**
    * Set the following CmekConfig as the default to be used for child resources
    * if one is not specified. The default value is true.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#set_default DiscoveryEngineCmekConfig#set_default}
    */
    readonly setDefault?: boolean | cdktf.IResolvable;
    /**
    * single_region_keys block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#single_region_keys DiscoveryEngineCmekConfig#single_region_keys}
    */
    readonly singleRegionKeys?: DiscoveryEngineCmekConfigSingleRegionKeys[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#timeouts DiscoveryEngineCmekConfig#timeouts}
    */
    readonly timeouts?: DiscoveryEngineCmekConfigTimeouts;
}
export interface DiscoveryEngineCmekConfigSingleRegionKeys {
    /**
    * Single-regional kms key resource name which will be used to encrypt
    * resources
    * 'projects/{project}/locations/{location}/keyRings/{keyRing}/cryptoKeys/{keyId}'.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#kms_key DiscoveryEngineCmekConfig#kms_key}
    */
    readonly kmsKey: string;
}
export declare function discoveryEngineCmekConfigSingleRegionKeysToTerraform(struct?: DiscoveryEngineCmekConfigSingleRegionKeys | cdktf.IResolvable): any;
export declare function discoveryEngineCmekConfigSingleRegionKeysToHclTerraform(struct?: DiscoveryEngineCmekConfigSingleRegionKeys | cdktf.IResolvable): any;
export declare class DiscoveryEngineCmekConfigSingleRegionKeysOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DiscoveryEngineCmekConfigSingleRegionKeys | cdktf.IResolvable | undefined;
    set internalValue(value: DiscoveryEngineCmekConfigSingleRegionKeys | cdktf.IResolvable | undefined);
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    get kmsKeyInput(): string | undefined;
}
export declare class DiscoveryEngineCmekConfigSingleRegionKeysList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DiscoveryEngineCmekConfigSingleRegionKeys[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DiscoveryEngineCmekConfigSingleRegionKeysOutputReference;
}
export interface DiscoveryEngineCmekConfigTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#create DiscoveryEngineCmekConfig#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#delete DiscoveryEngineCmekConfig#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#update DiscoveryEngineCmekConfig#update}
    */
    readonly update?: string;
}
export declare function discoveryEngineCmekConfigTimeoutsToTerraform(struct?: DiscoveryEngineCmekConfigTimeouts | cdktf.IResolvable): any;
export declare function discoveryEngineCmekConfigTimeoutsToHclTerraform(struct?: DiscoveryEngineCmekConfigTimeouts | cdktf.IResolvable): any;
export declare class DiscoveryEngineCmekConfigTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DiscoveryEngineCmekConfigTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DiscoveryEngineCmekConfigTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config google_discovery_engine_cmek_config}
*/
export declare class DiscoveryEngineCmekConfig extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_discovery_engine_cmek_config";
    /**
    * Generates CDKTF code for importing a DiscoveryEngineCmekConfig resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DiscoveryEngineCmekConfig to import
    * @param importFromId The id of the existing DiscoveryEngineCmekConfig that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DiscoveryEngineCmekConfig to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/discovery_engine_cmek_config google_discovery_engine_cmek_config} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DiscoveryEngineCmekConfigConfig
    */
    constructor(scope: Construct, id: string, config: DiscoveryEngineCmekConfigConfig);
    private _cmekConfigId?;
    get cmekConfigId(): string;
    set cmekConfigId(value: string);
    resetCmekConfigId(): void;
    get cmekConfigIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get isDefault(): cdktf.IResolvable;
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    get kmsKeyInput(): string | undefined;
    get kmsKeyVersion(): string;
    get lastRotationTimestampMicros(): number;
    private _location?;
    get location(): string;
    set location(value: string);
    get locationInput(): string | undefined;
    get name(): string;
    get notebooklmState(): string;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _setDefault?;
    get setDefault(): boolean | cdktf.IResolvable;
    set setDefault(value: boolean | cdktf.IResolvable);
    resetSetDefault(): void;
    get setDefaultInput(): boolean | cdktf.IResolvable | undefined;
    get state(): string;
    private _singleRegionKeys;
    get singleRegionKeys(): DiscoveryEngineCmekConfigSingleRegionKeysList;
    putSingleRegionKeys(value: DiscoveryEngineCmekConfigSingleRegionKeys[] | cdktf.IResolvable): void;
    resetSingleRegionKeys(): void;
    get singleRegionKeysInput(): cdktf.IResolvable | DiscoveryEngineCmekConfigSingleRegionKeys[] | undefined;
    private _timeouts;
    get timeouts(): DiscoveryEngineCmekConfigTimeoutsOutputReference;
    putTimeouts(value: DiscoveryEngineCmekConfigTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DiscoveryEngineCmekConfigTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
